#define MANY   8192
#define DEF_X  248     /* default image width  */
#define DEF_Y  248     /* default image height */

enum {
	RVAL = 257,   /* larger than any char token */
	LVAL,
	FNAME,
	VALUE,
	ARRAY,
	VALUEOF,
	VALUEOFAT,
	NAME,
	STRING,
	NEW,
	OLD,
	AND,
	OR,
	EQ,
	NE,
	GE,
	LE,
	UMIN,
	POW,
	LSH,
	RSH,
	ASSIGN,
	ASSIGNARR,
	MKCOLOR,
	SPECIAL_X,
	SPECIAL_Y,
	SPECIAL_Z,
	SPECIAL_x,
	SPECIAL_y,
	SPECIAL_RED,
	SPECIAL_GREEN,
	SPECIAL_BLUE,
	SPECIAL_LRED,
	SPECIAL_LGREEN,
	SPECIAL_LBLUE,
	COMMAND_SHOW
};

extern short CUROLD, CURNEW;

struct SRC {
	int encoding;
	union {
		u32int **pix;	/* color: pix[y][x] */
		uchar **bpix;	/* b&w: bpix[y][x] */
	};
	char *str;			/* name of image */
	int w;			/* width */
	int h;				/* height */
	int cx;			/* crop x - for getpix/putpix */
	int cy;			/* crop y - for getpix/putpix */
};

typedef struct Symbol { /* preliminary symbol item */
	char *name;
	int type;
	union {
		long value;
		struct {
			long *mem;
			ulong len;
		} arr;
	};
	struct Symbol *next;
} Symbol;

extern struct SRC src[MANY];
extern int symbolize, once;

#pragma varagck argpos error 1
#pragma varack type "T" int

extern int lex(void);
extern void putback(int);
extern void saveloc(void);
extern void putbackto(void);
extern void getpix(struct SRC *, char *);
extern void putpix(struct SRC *, char *);
extern void showfiles(void);
extern void transform(void);
extern void run(void);
extern void error(char *, ...);
extern void *emalloc(ulong);
extern void *erealloc(void *, ulong);
extern void initsymbols(void);
extern Symbol *lookup(char *);
extern Symbol *install(char *, int, long);
extern void showsymbols(void);
